<?php
/**
* GlossyAccordionMenu plugin
* This plugin allows you to insert the Glossy Accordion Menu
* with the tags {Glossy_Accordion_Menu} ... {/Glossy_Accordion_Menu}.
* Author: kksou
* Copyright (C) 2006-2008. kksou.com. All Rights Reserved
* License: GNU/GPL http://www.gnu.org/copyleft/gpl.html
* Website: http://www.kksou.com/php-gtk2
* v1.5 October 3, 2008
* v1.52 October 7, 2008 You can now easily change the style of the menu (including font style, size, foreground color, background color, etc.) by editing the css file directly. The css file is located in the folder mambots/content/GlossyAccordionMenu for Joomla 1.0, and plugins/content/GlossyAccordionMenu for Joomla 1.5.
* v1.53 December 9, 2008
- Fixed the warning message "Undefined variable: module on line 43"
- Fixed the warning message "Undefined offset: 0 on line 55"
* v1.54 March 1, 2010 Added one more parameter: "width" that allows you to set the width of the menu.
* v1.55 May 6, 2010 Conforms to joomla.org guidelines
*/

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

jimport( 'joomla.event.plugin' );

$lib = dirname(__FILE__).'/GlossyAccordionMenu/ddAccordionMenu.lib.php';
$lib2 = dirname(__FILE__).'/GlossyAccordionMenu/GlossyAccordionMenu.lib.php';
require_once($lib);
require_once($lib2);

class plgContentGlossyAccordionMenu extends JPlugin {

	function plgContentGlossyAccordionMenu( &$subject, $params ) {
		parent::__construct( $subject, $params );
 	}

	function onPrepareContent( &$row, &$params, $limitstart=0 ) {

		$plugin = new Plugin_GlossyAccordionMenu($row);

		return true;
	}
}

class Plugin_GlossyAccordionMenu extends GlossyAccordionMenu_base {

	function Plugin_GlossyAccordionMenu( &$row ) {

		$regex = '%\{Glossy_Accordion_Menu\s*(.*?)\s*\}(\n|\r\n|</p>|<p>|&nbsp;|<br\s/>)*(.*?)(\n|\r\n|</p>|<p>|&nbsp;|<br\s/>)*\{/Glossy_Accordion_Menu\}%is';

		$module = 'GlossyAccordionMenu';
		$this->get_param($module, '1.5');

		$plugin =& JPluginHelper::getPlugin('content', $module);
		$pluginParams = new JParameter( $plugin->params );
		if ( !$pluginParams->get( 'enabled', 1 ) ) {
			$row->text = preg_replace( $regex, '', $row->text );
			return true;
		}

		$contents = $row->text;
		if (preg_match_all( $regex, $contents, $matches_array, PREG_SET_ORDER )) {
			$count = count( $matches_array[0] );
			if ($count==0) return true;
			foreach($matches_array as $matches) {
				$this->process($row, $matches);
			}
			#$row->text = preg_replace( $regex, '', $row->text );
		}
		return true;
	}

}

?>
